#!/bin/sh

# speedup against sequential version

gnuplot <<EOF
set terminal postscript color
set output "speedup-growing-heap.ps"

set key outside

set xtics autofreq 1
set offsets 0.05,0.05,0.05

set xrange [1:2]
set yrange [0:3]
set xlabel "number of CPUs"
set ylabel "speedup"

set style line 1 lw 3 lt rgb "#edd400"
set style line 2 lw 3 lt rgb "#ce5c00"
set style line 3 lw 3 lt rgb "#8f5902"
set style line 4 lw 3 lt rgb "#4e9a06"
set style line 5 lw 3 lt rgb "#204a87"
set style line 6 lw 3 lt rgb "#5c3566"
set style line 7 lw 3 lt rgb "#a40000"
set style line 8 lw 3 lt rgb "#2e3436"

set style data errorlines
set style increment user
plot 'results-growing-heap/gc-bench' title "gc-bench", \
     'results-growing-heap/threaded-gc-bench' title "threaded-gc-bench", \
     'results-growing-heap/mandelbrot' title "mandelbrot", \
     'results-growing-heap/compile-series' title "compile-series", \
     'results-growing-heap/lindenmayer' title "lindenmayer", \
     'results-growing-heap/xuriella' title "xuriella", \
     'results-growing-heap/montezuma' title "montezuma", \
     'results-growing-heap/complete-rubbish' title "complete-rubbish"
#     'results-growing-heap/compile-clpython' title "compile-clpython"

#     'results-growing-heap/cl-ppcre' title "cl-ppcre", \


set output "speedup2-growing-heap.ps"

set xrange [1:2]
set yrange [1:3]

set offsets 0.05,0.05,0.05,0.05

plot 'results-growing-heap/gc-bench.s1' title "gc-bench", \
     'results-growing-heap/threaded-gc-bench.s1' title "threaded-gc-bench", \
     'results-growing-heap/mandelbrot.s1' title "mandelbrot", \
     'results-growing-heap/compile-series.s1' title "compile-series", \
     'results-growing-heap/lindenmayer.s1' title "lindenmayer", \
     'results-growing-heap/xuriella.s1' title "xuriella", \
     'results-growing-heap/montezuma.s1' title "montezuma", \
     'results-growing-heap/complete-rubbish.s1' title "complete-rubbish"

#     'results-growing-heap/cl-ppcre.s1' title "cl-ppcre", \

set output "balance-growing-heap.ps"

set xrange [1:2]
set yrange [1:3]
set xlabel "number of CPUs"
set ylabel "work balance"

set offsets 0.05,0.05,0.05,0.05

plot 'results-growing-heap/gc-bench.wb' title "gc-bench", \
     'results-growing-heap/threaded-gc-bench.wb' title "threaded-gc-bench", \
     'results-growing-heap/mandelbrot.wb' title "mandelbrot", \
     'results-growing-heap/compile-series.wb' title "compile-series", \
     'results-growing-heap/lindenmayer.wb' title "lindenmayer", \
     'results-growing-heap/xuriella.wb' title "xuriella", \
     'results-growing-heap/montezuma.wb' title "montezuma", \
     'results-growing-heap/complete-rubbish.wb' title "complete-rubbish"

#     'results-growing-heap/cl-ppcre.wb' title "cl-ppcre", \

EOF

#plot 'results-growing-heap/reference.gc-bench' w errorlines lt 1
