#!/bin/sh

sbcl <<EOF
(require 'asdf)
(sb-thread:join-thread
 (sb-thread:make-thread
  (lambda () (asdf:oos 'asdf:load-op 'delsegno :verbose nil))))

(ensure-directories-exist "results/")

(setf (sb-ext:bytes-consed-between-gcs) (/ 12582912 2))

(with-open-file (out "results/reference-with-big-heap.sexp"
                     :direction :output
                     :if-exists :supersede)
  (loop for benchmark in (delsegno:list-benchmarks)
        for result = (progn
                       (format t "~&;;; Running ~A ...~%" benchmark)
                       (sb-ext:gc :full t)
                       (first (delsegno:run-benchmark benchmark)))
        do (assert (eq (first result) :real-time))
        collect (list (intern (symbol-name benchmark))
                      (third (getf (cdr result) :mean))) into all
        finally (print all out)))
EOF
