#!/bin/sh

sh ~/sbcl-for-testing/run-sbcl.sh <<EOF
(require 'asdf)
(sb-thread:join-thread
 (sb-thread:make-thread
  (lambda () (asdf:oos 'asdf:load-op 'delsegno :verbose nil))))

(let ((ref (with-open-file (in "results/reference.sexp" :direction :input)
             (read in))))
  (with-open-file (out "results/all.vp" :direction :output
                       :if-exists :supersede)
    (dolist (benchmark (delsegno:list-benchmarks))
      (format t "~&;;; Running ~A ..." benchmark)
      (sb-ext:gc :full t)
      (let* ((results (delsegno:run-benchmark benchmark :events '(:real-time)))
             (real-time (find :real-time results :key #'first)))
        ;; speedup against original version
        (let* ((refval (second (find benchmark ref :key 'car
                                     :test 'string-equal)))
               (mean (third (getf (cdr real-time) :mean)))
               (nmean (/ refval mean))
               (stddev (third (getf (cdr real-time) :stddev)))
               (nstddev (/ (* stddev nmean) mean)))
          (format out "~A ~F ~F~%"
                  (string-downcase benchmark) nmean nstddev))))))
EOF