(in-package #:delsegno)

(define-benchmark mandelbrot ()
  (cl-pdf-examples::example9 300 300))

(define-benchmark lindenmayer ()
  (cl-pdf-examples::pdf-l-system-centered
   '(("F"."FF-[-F+F+F]+[+F-F-F]")) "+F" 23 5))

(define-benchmark xuriella ()
  (xuriella::run-tests :verbose nil))

(define-benchmark cl-ppcre ()
  (cl-ppcre-test:run-all-tests))

(eval-when (:compile-toplevel :load-toplevel :execute)
  (load (asdf:system-relative-pathname
         'montezuma "tests/corpora/reuters-21578/indexer.lisp")))

(define-benchmark montezuma ()
  (reuters-indexer::runit))

#+#:ignore ; needs too recent an SBCL
(define-benchmark compile-clpython ()
  (asdf:oos 'asdf:load-op 'clpython :force t :verbose nil))

(define-benchmark compile-series ()
  (asdf:oos 'asdf:load-op 'series :force t :verbose nil))